using namespace std;

struct NodoAlbero 
{
	int info;
	NodoAlbero *left, *right, *father;
};

typedef NodoAlbero * Albero;

/* Inizializza l'albero vuoto */
void initAlbero(Albero& a);

/* y diventa radice dell'albero se questo inizialmente vuoto */
void createRoot(Albero& a, int info);

/* verifica se l'albero  vuoto o meno */
int isEmpty(Albero& a);

/* restituisce il padre di x */
NodoAlbero* getFather(NodoAlbero* x);

/* restituisce figlio sinistro di x */
NodoAlbero* getLeft(NodoAlbero* x);

/* restituisce figlio destro di x */
NodoAlbero* getRight(NodoAlbero* x);

/* inserisce y come figlio di x, prova ad inserirlo prima
   come figlio dx, se e' gia' presente come figlio sx, 
   se e' gia' presente anche questo non fa nulla, 
   restituisce il puntatore al nodo inserito, NULL se non 
   viene inserito nulla */
NodoAlbero* insert(NodoAlbero* x, int info);

/* cancella un nodo solo se x e' foglia */
void del(NodoAlbero* x);

/* dealloca la memoria occupata da un albero */
void deallocaAlbero(Albero& a);
