#ifndef LISTA_H
#define LISTA_H

using namespace std;

typedef struct NodoLista 
{
    int info;
	struct NodoLista* next;
} *Lista;

/* Inizializza lis alla lista vuota. */
void InitLista(Lista& lis);

/**********************
** INSERIMENTI ***
************************/

/* Inserisce l'elemento elem in testa alla lista */
void InsTesta(Lista& lis, int elem);
/* Inserisce l'elemento elem in coda alla lista */
void InsCoda(Lista& lis, int elem);
/* Inserisce l'elemento in posizione k-esima */
void InsPos(Lista& lis, int elem, int k);

/**********************
** ESTRAZIONI ***
************************/

/* Estrae l'elemento in testa alla lista in maniera
   non distruttiva */
void EstrTesta(Lista& lis, int& elem);
/* Estrae l'elemento in coda alla lista in maniera
   non distruttiva */
void EstrCoda(Lista& lis, int& elem);
/* Estrae l'elemento in posizione k-esima in maniera 
   non distruttiva */
void EstrPos(Lista& lis, int& elem, int k);

/**********************
** ELIMINAZIONE ***
************************/

/* Elimina la testa della lista */
void DelTesta(Lista& lis);
/* Elimina la coda della lista */
void DelCoda(Lista& lis);
/* Elimina l'elemento in posizione k-esima */
void DelPos(Lista& lis, int k);

/**********************
** TEST ***
************************/

/* Restituisce TRUE se lis e` la lista vuota, FALSE altrimenti. */
int Empty(Lista& lis);

/* Restituisce TRUE se l'elemento e' contenuto nella lista */
bool esiste(Lista& l, int& elem);

/*
Elimina dalla lista tutti gli elementi di posto pari
*/
int eliminaElemPostoPari(Lista& l);
/*
Elimina dalla lista tutti gli elementi di posto dispari
*/
int eliminaElemPostoDispari(Lista& l);

/* Ribalta gli elementi nella lista in modo iterativo */
void ribaltaIterativo(Lista& l);

/* Ribalta gli elementi nella lista in modo ricorsivo */
Lista& ribaltaRicorsivo(Lista& l);

#endif