#include <iostream>
#include "lista.h"

using namespace std;

void InitLista(Lista& lis) {
    lis = NULL;
}

void InsTesta(Lista& lis, int elem) {
	NodoLista* paux;

    paux = new NodoLista();     
    paux->info = elem;                     
    paux->next = lis;                      
    lis = paux;  
}  


void InsCoda(Lista& lis, int elem) {
    NodoLista* ultimo;   /* puntatore usato per la scansione */
    NodoLista* paux;

    /* creazione del record che contiene il nuovo elemento */
    paux = new NodoLista(); 
    paux->info = elem;
    paux->next = NULL;   /* il record sara` l'ultimo della lista */
  
    if (lis == NULL)
        lis = paux;
    else {
        ultimo = lis;
        while (ultimo->next != NULL)
            ultimo = ultimo->next;
        /* concatenazione del nuovo record in coda alla lista */
        ultimo->next = paux;                 
    }
}

void InsPos(Lista& lis, int elem, int k) {
    NodoLista* paux;
    NodoLista* curr;    /* puntatore usato per la scansione */
    
    /* scorriamo la lista fino a trovare la giusta posizione */
    curr = lis;
    int i = 0;
    while (i<(k-1) && curr!=NULL) {
        curr = curr->next;
        i++;
    }
    
    /* creazione del record che contiene il nuovo elemento 
       e concatenazione nella lista */
    if (curr!=NULL) {
        paux = new NodoLista();
        paux->info = elem;
        paux->next = curr->next;
        curr->next = paux;
    }
}

void EstrTesta(Lista& lis, int& elem) {
    if (lis != NULL)
        elem = lis->info;
}

void EstrCoda(Lista& lis, int& elem) {
    NodoLista* ultimo;   /* puntatore usato per la scansione */
    
    if (lis != NULL) {
        ultimo = lis;
        while (ultimo->next != NULL)
            ultimo = ultimo->next;
        elem = ultimo->info;
    }
    
}

void EstrPos(Lista& lis, int& elem, int k) {
    NodoLista* curr;    /* puntatore usato per la scansione */
    
    /* scorriamo la lista fino a trovare la giusta posizione */
    curr = lis;
    int i = 0;
    while (i<k && curr!=NULL) {
        curr = curr->next;
        i++;
    }
    
    /* creazione del record che contiene il nuovo elemento */
    if (curr!=NULL) {
        elem = curr->info;
    }
    
}

void DelTesta(Lista& lis) {
    NodoLista* toDel; 
    
    if (lis != NULL) {
        toDel = lis;
        lis = lis->next;
        delete(toDel);
    }
}

void DelCoda(Lista& lis) {
    NodoLista* ultimo;   /* puntatore usato per la scansione */
    NodoLista* pen_ultimo;
    
    if (lis != NULL) {
        ultimo = lis;
        pen_ultimo = ultimo;
        while (ultimo->next != NULL) {
            pen_ultimo = ultimo;
            ultimo = ultimo->next;
        }      
        pen_ultimo->next = NULL;
        delete(ultimo);
    }
}

void DelPos(Lista& lis, int k) {
    NodoLista* curr;    /* puntatore usato per la scansione */
    NodoLista* prev;    /* puntatore usato per la scansione */
    
    /* scorriamo la lista fino a trovare la giusta posizione */
    curr = lis;
    prev = curr;
    int i = 0;
    while (i<k && curr!=NULL) {
        prev = curr;
        curr = curr->next;
        i++;
    }

    if (curr!=NULL) {
        if (prev != curr) {
            prev->next = curr->next;
            delete(curr);
        }
        else {  /* cancellazione della testa */
            lis = lis->next;
            delete(curr);
        }
    }
}

bool esiste(Lista& l, int& elem){
  while(l != NULL && l->info != elem)
    l = l->next;
  if(l != NULL) return true;
  else return false;
}


    
      

